Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 2, 2010

entity CURVE_MEM_MUX4 is 
	port( 
			CURVE_0		: in std_logic_vector(31 downto 0);
			CURVE_1		: in std_logic_vector(31 downto 0);
			CURVE_2		: in std_logic_vector(31 downto 0);
			CURVE_3		: in std_logic_vector(31 downto 0);
			CURVE_4		: in std_logic_vector(31 downto 0);
			CURVE_5		: in std_logic_vector(31 downto 0);
			CURVE_6		: in std_logic_vector(31 downto 0);
			CURVE_7		: in std_logic_vector(31 downto 0);
			CURVE_8		: in std_logic_vector(31 downto 0);
			CURVE_9		: in std_logic_vector(31 downto 0);
			
			ADDR		: in std_logic_vector(15 downto 12);
			
			CURVE_OUT	: out std_logic_vector(31 downto 0)
			
			
		);
	end CURVE_MEM_MUX4;
	
architecture main of CURVE_MEM_MUX4 is	
begin
	process (ADDR, CURVE_0, CURVE_1, CURVE_2, CURVE_3, CURVE_4,
			 CURVE_5, CURVE_6, CURVE_7, CURVE_8, CURVE_9)
	begin
		case ADDR is
			when X"0" => CURVE_OUT <= CURVE_0;
			when X"1" => CURVE_OUT <= CURVE_1;
			when X"2" => CURVE_OUT <= CURVE_2;
			when X"3" => CURVE_OUT <= CURVE_3;
			when X"4" => CURVE_OUT <= CURVE_4;
			when X"5" => CURVE_OUT <= CURVE_5;
			when X"6" => CURVE_OUT <= CURVE_6;
			when X"7" => CURVE_OUT <= CURVE_7;
			when X"8" => CURVE_OUT <= CURVE_8;
			when X"9" => CURVE_OUT <= CURVE_9;
						              
			when others => CURVE_OUT <= X"00000000";
		end case;
	end process;
end;