Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 30, 2015

entity CURVE_MEM_MUX8 is 
	port( 
			CURVE_0		: in std_logic_vector(15 downto 0);
			CURVE_1		: in std_logic_vector(15 downto 0);
			CURVE_2		: in std_logic_vector(15 downto 0);
			CURVE_3		: in std_logic_vector(15 downto 0);
			CURVE_4		: in std_logic_vector(15 downto 0);
			CURVE_5		: in std_logic_vector(15 downto 0);
			CURVE_6		: in std_logic_vector(15 downto 0);
			CURVE_7		: in std_logic_vector(15 downto 0);
			
			ADDR			: in std_logic_vector(16 downto 12);
			
			CURVE_OUT	: out std_logic_vector(15 downto 0)
			
			
		);
	end CURVE_MEM_MUX8;
	
architecture main of CURVE_MEM_MUX8 is	
begin
	process (ADDR, CURVE_0, CURVE_1, CURVE_2, CURVE_3, 
					CURVE_4, CURVE_5, CURVE_6, CURVE_7)
	begin
		case ADDR is
			when "01010" => CURVE_OUT <= CURVE_0;
			when "01011" => CURVE_OUT <= CURVE_1;
			when "01100" => CURVE_OUT <= CURVE_2;
			when "01101" => CURVE_OUT <= CURVE_3;
			when "01110" => CURVE_OUT <= CURVE_4;
			when "01111" => CURVE_OUT <= CURVE_5;
			when "10000" => CURVE_OUT <= CURVE_6;
			when "10001" => CURVE_OUT <= CURVE_7;
						              
			when others => CURVE_OUT <= X"0000";
		end case;
	end process;
end;