Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 
USE work.DDS_VME_CONSTANTS.all;

entity DAC_3_4_Regs is 
	port( 	
			clk			: in std_logic;
			nreset		: in std_logic;
			
			Data_to_Mem : in std_logic_vector(31 downto 0);
			Addr_to_Mem	: in std_logic_vector(23 downto 0);
			WR			: in std_logic;	
			
			DAC_3_Data_Out	: out std_logic_vector(15 downto 0);
			DAC_4_Data_Out	: out std_logic_vector(15 downto 0);
			DAC_Strb_Out	: out std_logic
		);
	end DAC_3_4_Regs;
	
architecture main of DAC_3_4_Regs is	

signal ADDR 		: std_logic_vector(23 downto 0);

signal dac_3_out	: std_logic_vector(15 downto 0);
signal dac_4_out	: std_logic_vector(15 downto 0);
signal q1,q2,q3	: std_logic;
            
begin
	
	ADDR <= Addr_to_Mem;
	
	DAC_REGISTERS: process(clk, nreset, WR, ADDR, Data_to_Mem)
	begin	
		if (nreset = '0') then
			dac_3_out <= X"8000";--(others => '0');
			dac_4_out <= X"8000";--(others => '0');
			q1 <= '0';
			q2 <= '0';
			q3 <= '0';
			
		elsif rising_edge(clk) then
			if   (ADDR = DAC_3_4_REGISTER) then 
						dac_3_out <= Data_to_Mem(15 downto 0);
						dac_4_out <= Data_to_Mem(31 downto 16);
						q1 <= WR;
			end if;           
			q2 <= q1;
			q3 <= q2;			
		end if;
	end process;
 
			DAC_3_Data_Out	<= dac_3_out;
			DAC_4_Data_Out	<= dac_4_out;	
			DAC_Strb_Out	<= q2 and not q3; -- LED
 
          
end;