Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 17, 2010
--
-- This module compares the highest 4 VME address bits (31 .. 28) to the 
-- board address DIP switches.  These 4 bits determine whether the board 
-- is being addressed during an extended mode VME transfer.

-- VME Address bits 25 and 24 are the only bits from the J2/P2 bus that
-- need to be passed on to the Upper FPGA for memory map address decoding.

entity Lower_VME is 
	port( 
			VME_Addr	: in std_logic_vector(31 downto 24);
			Board_Addr	: in std_logic_vector(3 downto 0);
			
			VME_Ext_Addr 	: out std_logic_vector(25 downto 24);
			Ext_Board_Sel	: out std_logic       
		);
	end Lower_VME;
	
architecture main of Lower_VME is	


begin
VME_Ext_Addr(25 downto 24) <= VME_Addr(25 downto 24);
	
	process (VME_Addr, Board_Addr)
	begin
		if (VME_Addr(31 downto 28) = Board_Addr(3 downto 0)) then
			Ext_Board_Sel <= '1';
		else
			Ext_Board_Sel <= '0';
		end if;
			
	end process;
end;