Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 
USE work.DDS_VME_CONSTANTS.all;

----------------------------------------------------------------

entity Mux_4x1 is 
	port( 	
			clk			: in std_logic;
			nreset		: in std_logic;
			
			Sel_nA_B		: in std_logic;			
			
			A_1	: in std_logic;
			A_2	: in std_logic;
			A_3	: in std_logic;
			A_4	: in std_logic;

			B_1	: in std_logic;
			B_2	: in std_logic;
			B_3	: in std_logic;
			B_4	: in std_logic;
			
			Out_1	: out std_logic;
			Out_2	: out std_logic;
			Out_3	: out std_logic;
			Out_4	: out std_logic
		);
	end Mux_4x1;
	
architecture main of Mux_4x1 is	

           
begin
	SYNCRONIZE_SAMPLE:
	process(clk, nreset, Sel_nA_B, A_1, A_2, A_3, A_4, B_1, B_2, B_3, B_4)
    begin
		if   (nreset = '0') then 
			Out_1 <= '0';
			Out_2 <= '0';
			Out_3 <= '0';
			Out_4 <= '0';
		
      elsif rising_edge(clk) then
			if   (Sel_nA_B = '0') then
				Out_1 <= A_1;
				Out_2 <= A_2;
				Out_3 <= A_3;
				Out_4 <= A_4;
			else
				Out_1 <= B_1;
				Out_2 <= B_2;
				Out_3 <= B_3;
				Out_4 <= B_4;
			end if;			
		end if;
    end process;
              
end;