Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 2, 2010

entity WR_Addr_Decoder4 is 
	port( 
			WR_mem		: in std_logic;			
			ADDR		: in std_logic_vector(15 downto 12);
			
			WR_curve_0	: out std_logic;
			WR_curve_1	: out std_logic;
			WR_curve_2	: out std_logic;
			WR_curve_3	: out std_logic;
			WR_curve_4	: out std_logic;
			WR_curve_5	: out std_logic;
			WR_curve_6	: out std_logic;
			WR_curve_7	: out std_logic;
			WR_curve_8	: out std_logic;
			WR_curve_9	: out std_logic
			        
		);
	end WR_Addr_Decoder4;
	
architecture main of WR_Addr_Decoder4 is	

signal WR : std_logic;
begin
	
	WR <= WR_mem;
	
	process (ADDR, WR)
	begin
			WR_curve_0	<= '0';
			WR_curve_1	<= '0';
			WR_curve_2	<= '0';
			WR_curve_3	<= '0';
			WR_curve_4	<= '0';
			WR_curve_5	<= '0';
			WR_curve_6	<= '0';
			WR_curve_7	<= '0';
			WR_curve_8	<= '0';
			WR_curve_9	<= '0';

		case ADDR is
			when X"0" => WR_curve_0 <= WR;
			when X"1" => WR_curve_1 <= WR;
			when X"2" => WR_curve_2 <= WR;
			when X"3" => WR_curve_3 <= WR;
			when X"4" => WR_curve_4 <= WR;
			when X"5" => WR_curve_5 <= WR;
			when X"6" => WR_curve_6 <= WR;
			when X"7" => WR_curve_7 <= WR;
			when X"8" => WR_curve_8 <= WR;
			when X"9" => WR_curve_9 <= WR;
			when others => NULL;			              
		end case;
	end process;
end;