Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, March 30, 2015

entity WR_Addr_Decoder8 is 
	port( 
			WR_mem		: in std_logic;			
			ADDR			: in std_logic_vector(16 downto 12);
			
			WR_curve_0	: out std_logic;
			WR_curve_1	: out std_logic;
			WR_curve_2	: out std_logic;
			WR_curve_3	: out std_logic;
			WR_curve_4	: out std_logic;
			WR_curve_5	: out std_logic;
			WR_curve_6	: out std_logic;
			WR_curve_7	: out std_logic
		);
	end WR_Addr_Decoder8;
	
architecture main of WR_Addr_Decoder8 is	

signal WR : std_logic;
begin
	
	WR <= WR_mem;
	
	process (ADDR, WR)
	begin
			WR_curve_0	<= '0';
			WR_curve_1	<= '0';
			WR_curve_2	<= '0';
			WR_curve_3	<= '0';
			WR_curve_4	<= '0';
			WR_curve_5	<= '0';
			WR_curve_6	<= '0';
			WR_curve_7	<= '0';

		case ADDR is
			when "01010" => WR_curve_0 <= WR;
			when "01011" => WR_curve_1 <= WR;
			when "01100" => WR_curve_2 <= WR;
			when "01101" => WR_curve_3 <= WR;
			when "01110" => WR_curve_4 <= WR;
			when "01111" => WR_curve_5 <= WR;
			when "10000" => WR_curve_6 <= WR;
			when "10001" => WR_curve_7 <= WR;
			when others => NULL;			              
		end case;
	end process;
end;