Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 
USE work.DDS_VME_CONSTANTS.all;

-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, 

entity Test_Bits_Mux is 
	port( 
			VME_Ctrl	: in std_logic_vector(3 downto 0);
			A1_in		: in std_logic;
			A2_in		: in std_logic;
			A3_in		: in std_logic;
			A4_in		: in std_logic;

			B1_in		: in std_logic;
			B2_in		: in std_logic;
			B3_in		: in std_logic;
			B4_in		: in std_logic;

			C1_in		: in std_logic;
			C2_in		: in std_logic;
			C3_in		: in std_logic;
			C4_in		: in std_logic;

			D1_in		: in std_logic;
			D2_in		: in std_logic;
			D3_in		: in std_logic;
			D4_in		: in std_logic;

			E1_in		: in std_logic;
			E2_in		: in std_logic;
			E3_in		: in std_logic;
			E4_in		: in std_logic;

			F1_in		: in std_logic;
			F2_in		: in std_logic;
			F3_in		: in std_logic;
			F4_in		: in std_logic;

			G1_in		: in std_logic;
			G2_in		: in std_logic;
			G3_in		: in std_logic;
			G4_in		: in std_logic;

			H1_in		: in std_logic;
			H2_in		: in std_logic;
			H3_in		: in std_logic;
			H4_in		: in std_logic;

			Y1_out		: out std_logic;
			Y2_out		: out std_logic;
			Y3_out		: out std_logic;
			Y4_out		: out std_logic
		);
	end Test_Bits_Mux;
	
architecture main of Test_Bits_Mux is	



begin	
	
	process(VME_Ctrl, 
			A1_in, A2_in, A3_in, A4_in, 
			B1_in, B2_in, B3_in, B4_in, 
			C1_in, C2_in, C3_in, C4_in, 
			D1_in, D2_in, D3_in, D4_in, 
			E1_in, E2_in, E3_in, E4_in, 
			F1_in, F2_in, F3_in, F4_in, 
			G1_in, G2_in, G3_in, G4_in, 
			H1_in, H2_in, H3_in, H4_in 			                     
		   )
	begin
		case VME_Ctrl is
			when X"0" => 
						Y1_out <= A1_in;
						Y2_out <= A2_in;
						Y3_out <= A3_in;
						Y4_out <= A4_in;
	                                 
			when X"1" => 
						Y1_out <= B1_in;
						Y2_out <= B2_in;
						Y3_out <= B3_in;
						Y4_out <= B4_in;
	                                 
			when X"2" => 
						Y1_out <= C1_in;
						Y2_out <= C2_in;
						Y3_out <= C3_in;
						Y4_out <= C4_in;
	                                 
			when X"3" => 
						Y1_out <= D1_in;
						Y2_out <= D2_in;
						Y3_out <= D3_in;
						Y4_out <= D4_in;
						
			when X"4" => 
						Y1_out <= E1_in;
						Y2_out <= E2_in;
						Y3_out <= E3_in;
						Y4_out <= E4_in;
	                                 
			when X"5" => 
						Y1_out <= F1_in;
						Y2_out <= F2_in;
						Y3_out <= F3_in;
						Y4_out <= F4_in;
	                                 
			when X"6" => 
						Y1_out <= G1_in;
						Y2_out <= G2_in;
						Y3_out <= G3_in;
						Y4_out <= G4_in;
	                                 
			when X"7" => 
							Y1_out <= H1_in;
							Y2_out <= H2_in;
							Y3_out <= H3_in;
							Y4_out <= H4_in;
	                                    
			
			when others => 
							Y1_out <= A1_in;
							Y2_out <= A2_in;
							Y3_out <= A3_in;
							Y4_out <= A4_in;
		end case;
	                                    
	end process;
end;