Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 
USE work.DDS_VME_CONSTANTS.all;
-------------------------------------------------------------------------------
-- MODULE DESCRIPTION, April 4, 2016

entity Upper_Addr_Decoder_v7 is 
	port( 
			Addr_to_Mem		: in std_logic_vector(23 downto 0);
			WR_Pulse		: in std_logic;			

			SM_Data_Out		: in std_logic_vector(31 downto 0);
			Setup_Data_Out	: in std_logic_vector(31 downto 0);
			PP_Data_Out		: in std_logic_vector(31 downto 0);
			PA_Data_Out		: in std_logic_vector(31 downto 0);
			PB_Data_Out		: in std_logic_vector(31 downto 0);
			Param_Reg_Out	: in std_logic_vector(31 downto 0);
			Flash_Count_Out : in std_logic_vector(31 downto 0);
			Lower_Data_Out	: in std_logic_vector(31 downto 0);
			
			Data_Out		: out std_logic_vector(31 downto 0);
			WR_SM			: out std_logic;
			WR_PP			: out std_logic;
			WR_PA			: out std_logic;
			WR_PB			: out std_logic;
			WR_SETUP		: out std_logic;
			WR_FC			: out std_logic;
			WR_LOWER		: out std_logic
			        
		);
	end Upper_Addr_Decoder_v7;
	
architecture main of Upper_Addr_Decoder_v7 is
	
signal WR   : std_logic;
signal ADDR : std_logic_vector(23 downto 0);

begin	
	
	WR <= WR_Pulse;
	ADDR <= Addr_to_Mem;	
	
	process (ADDR, WR, SM_Data_Out, Setup_Data_Out, PP_Data_Out, Flash_Count_Out, 
				PA_Data_Out, PB_Data_Out, Param_Reg_Out, Lower_Data_Out )
	begin
				WR_FC		<= '0';
				WR_SM		<= '0';
            WR_SETUP	<= '0';
            WR_PP		<= '0';	
            WR_PA		<= '0';	
            WR_PB		<= '0';	
            WR_LOWER	<= '0';
			Data_Out <= X"0000BAD4";
		
		if(ADDR = FLASH_WRITE_COUNT) then WR_FC <= WR; 		Data_Out <= Flash_Count_Out;
		
		elsif(ADDR < X"014000") then     WR_SM <= WR; 		Data_Out <= SM_Data_Out;
		elsif(ADDR < X"014400") then  	WR_SETUP <= WR; 	Data_Out <= Setup_Data_Out;   
		elsif(ADDR < X"014800") then 	       NULL; 
		elsif(ADDR < X"015000") then     WR_PP <= WR; 		Data_Out <= PP_Data_Out; 
		elsif(ADDR < X"01A000") then     WR_PA <= WR; 		Data_Out <= PA_Data_Out;
		elsif(ADDR < X"01F000") then     WR_PB <= WR; 		Data_Out <= PB_Data_Out;
		elsif(ADDR < X"01F100") then    			  		 		Data_Out <= Param_Reg_Out;
		elsif(ADDR < X"020000") then 	       NULL; 
		elsif(ADDR < X"080000") then  	WR_LOWER <= WR; 	Data_Out <= Lower_Data_Out;
		end if;

	end process;
end;