Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

-- My Definitions --------------------------------
USE work.pkg_081006.all; 
USE work.DDS_VME_CONSTANTS.all;

----------------------------------------------------------------

entity Upper_Monitor_Regs is 
	port( 	
			clk				: in std_logic;
			nreset			: in std_logic;
			Addr_to_Mem		: in std_logic_vector(23 downto 0);
			
			Monitor_In_0	: in std_logic_vector(31 downto 0);
			Monitor_In_1	: in std_logic_vector(31 downto 0);
			Monitor_In_2	: in std_logic_vector(31 downto 0);
			Monitor_In_3	: in std_logic_vector(31 downto 0);
			Monitor_In_4	: in std_logic_vector(31 downto 0);
			Monitor_In_5	: in std_logic_vector(31 downto 0);
			Monitor_In_6	: in std_logic_vector(31 downto 0);
			Monitor_In_7	: in std_logic_vector(31 downto 0);
						
			Monitor_Data_Out	: out std_logic_vector(31 downto 0)
		);
	end Upper_Monitor_Regs;
	
architecture main of Upper_Monitor_Regs is	

signal ADDR 	 : std_logic_vector(23 downto 0);
signal selected : std_logic;

signal mon_0	: std_logic_vector(31 downto 0);
signal mon_1	: std_logic_vector(31 downto 0);
signal mon_2	: std_logic_vector(31 downto 0);
signal mon_3	: std_logic_vector(31 downto 0);
signal mon_4	: std_logic_vector(31 downto 0);
signal mon_5	: std_logic_vector(31 downto 0);
signal mon_6	: std_logic_vector(31 downto 0);
signal mon_7	: std_logic_vector(31 downto 0);


begin
	--------------------------------------------------------------
	ADDR <= Addr_to_Mem;
	--------------------------------------------------------------
	MONITOR_REGISTERS: 
	process(clk, nreset, Monitor_In_0, Monitor_In_1, Monitor_In_2, 
				Monitor_In_3, Monitor_In_4, Monitor_In_5, Monitor_In_6, 
				Monitor_In_7)
	begin	
		if rising_edge(clk) then
			if (nreset = '0') then
				mon_0	<= (others => '0');
				mon_1	<= (others => '0');
				mon_2	<= (others => '0');
				mon_3	<= (others => '0');
				mon_4	<= (others => '0');
				mon_5	<= (others => '0');
				mon_6	<= (others => '0');
				mon_7	<= (others => '0');

			elsif( selected = '0') then -- hold register when being read
				mon_0	<= Monitor_In_0;
				mon_1	<= Monitor_In_1;
				mon_2	<= Monitor_In_2;
				mon_3	<= Monitor_In_3;
				mon_4	<= Monitor_In_4;
				mon_5	<= Monitor_In_5;
				mon_6	<= Monitor_In_6;
				mon_7	<= Monitor_In_7;
			end if;                                            
		end if;
	end process;
       
	DATA_OUT_MUX: 
	process(ADDR, mon_0, mon_1, mon_2, mon_3, mon_4, mon_5, mon_6, mon_7)
	begin	
			selected <= '0'; -- default
 
			case ADDR is
				when MONITOR_REG_FIRST 		 => Monitor_Data_Out <= mon_0;
														 selected <= '1';
				when MONITOR_REG_FIRST + 4  => Monitor_Data_Out <= mon_1;
														 selected <= '1';
				when MONITOR_REG_FIRST + 8  => Monitor_Data_Out <= mon_2;
														 selected <= '1';
				when MONITOR_REG_FIRST + 12 => Monitor_Data_Out <= mon_3;
														 selected <= '1';
				when MONITOR_REG_FIRST + 16 => Monitor_Data_Out <= mon_4;
														 selected <= '1';
				when MONITOR_REG_FIRST + 20 => Monitor_Data_Out <= mon_5;
														 selected <= '1';
				when MONITOR_REG_FIRST + 24 => Monitor_Data_Out <= mon_6;
														 selected <= '1';
				when MONITOR_REG_FIRST + 28 => Monitor_Data_Out <= mon_7;
														 selected <= '1';
				when others =>						 Monitor_Data_Out <= mon_0;
														 selected <= '0'; -- not selected
			end case;				
	end process;
end;